﻿using fds.bestin;
using fds.bestin.util;
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace fds_bestin_net
{
    public partial class MainForm : Form
    {
        private SOAClient soaClient = null;
        public MainForm()
        {
            InitializeComponent();
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            this.cbMemberRole.SelectedIndex = 0;
            this.cbIdentityType.SelectedIndex = 0;

            soaClient = new SOAClient();

            //公私钥设置
            string str = Environment.CurrentDirectory;
            soaClient.setRSAKey(str + "\\cert\\cloud_rsa_public.cer", str + "\\cert\\rsa_private_key.pfx", "123456");
            soaClient.setDSAKey(str + "\\cert\\cloud_dsa_public.cer", str + "\\cert\\dsa_private_key.pfx", "123456");

            soaClient.setServerUrl("http://118.178.141.90:9001/fds/service/soa");
            soaClient.setWebUrl("http://118.178.141.90:9001/fds/api/view");
            soaClient.setAppId("6428120455743414272");
            soaClient.setVersion("2.0");


            this.tbOutMemberNo.Text = Guid.NewGuid().ToString().Replace("-", "");
            this.tbName.Text = "张三";
            this.tbIdentityNo.Text = "330571198408141234";
            this.tbMobile.Text = "13811111111";
            this.tbFrontUrl.Text = "http://www.baidu.com";
            this.tbBackUrl.Text = "http://www.baidu.com";

            this.tbMemberNo.Text = "6428120456427085824";
        }

        private string getMemberRole(int i)
        {
            switch (i) {
                case 0:
                    return "R102";
                case 1:
                    return "R101";
                case 2:
                    return "R000";
                case 3:
                    return "R001";
                case 4:
                    return "R002";
                case 5:
                    return "R000";
                default:
                    return "";
            };
        }

        private string getIdentityType(int i)
        {
            switch (i)
            {
                case 0:
                    return "1";
                default:
                    return "";
            };
        }

        /// <summary>
        /// 个人开户
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnMember_Click(object sender, EventArgs e)
        {
            Dictionary<string, object> param = new Dictionary<string, object>();
            param.Add("out_member_no", tbOutMemberNo.Text.Trim());
            param.Add("member_role", getMemberRole(cbMemberRole.SelectedIndex));
            param.Add("name", tbName.Text.Trim());
            param.Add("identity_type", getIdentityType(cbIdentityType.SelectedIndex));
            param.Add("identity_no", RSAUtil.encrypt(soaClient.getRsaPublicKey(), tbIdentityNo.Text.Trim()));
            param.Add("mobile", tbMobile.Text.Trim());
            param.Add("front_url", tbFrontUrl.Text.Trim());
            param.Add("back_url", tbBackUrl.Text.Trim());

            string url = soaClient.getWebUrl("member.person.create", param);
            Process.Start(url);
        }

        /// <summary>
        /// 余额查询
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnAccountAmount_Click(object sender, EventArgs e)
        {
            Dictionary<string, object> param = new Dictionary<string, object>();
            param.Add("member_no", tbMemberNo.Text.Trim());
            param.Add("account_type", "1000");

            try
            {
                JObject rel = soaClient.call("account.balance.get", param);
                this.tbCallbackResult.Text = rel.ToString();
            }
            catch (Exception ex)
            {
                Debug.Write(ex.StackTrace);
            }

        }
    }
}
