﻿using System.Security.Cryptography;
using System.Text;

namespace fds.bestin.util
{
    public class MD5Util
    {
        /// <summary>
        /// 签名
        /// </summary>
        /// <param name="val"></param>
        /// <returns></returns>
        public static string sign(string val)
        {
            MD5 md5 = MD5.Create();
            byte[] inputBytes = Encoding.UTF8.GetBytes(val);
            byte[] hash = md5.ComputeHash(inputBytes);
            StringBuilder sb = new StringBuilder();
            for (int i = 0; i < hash.Length; i++)
            {
                sb.Append(hash[i].ToString("X2"));
            }
            return sb.ToString();
        }

        /// <summary>
        /// 验证签名
        /// </summary>
        /// <param name="text"></param>
        /// <param name="signature"></param>
        /// <returns></returns>
        public static bool verify(string text, string signature)
        {
            MD5 md5 = MD5.Create();
            byte[] inputBytes = Encoding.UTF8.GetBytes(text);
            byte[] hash = md5.ComputeHash(inputBytes);
            StringBuilder sb = new StringBuilder();
            for (int i = 0; i < hash.Length; i++)
            {
                sb.Append(hash[i].ToString("X2"));
            }
            if (sb.ToString().Equals(signature, System.StringComparison.CurrentCultureIgnoreCase))
                return true;
            return false;
        }
    }
}