package demo;

import com.alibaba.fastjson.JSONObject;
import demo.comm.DSAUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;

/**
 * SOA后台通知接收示例
 *
 * @author: Fish
 * @date: 2020/07/21
 **/
@RestController
public class SoaBackNoticeControllerDemo {
    private static final Logger log = LoggerFactory.getLogger(SoaBackNoticeControllerDemo.class);

    //钱帐通的DSA公钥
    private static final String DSA_PUBLIC_KEY = "";

    /**
     * 接收后台通知
     * @param request
     * @return
     */
    @RequestMapping("/backNoticeDemo")
    public Object backNoticeDemo(HttpServletRequest request) {
        String app_id = request.getParameter("app_id");
        String timestamp = request.getParameter("timestamp");
        String version = request.getParameter("version");
        String sign = request.getParameter("sign");
        String event_type = request.getParameter("event_type");
        String event = request.getParameter("event");
        log.info("/backNoticeDemo, appId:{}, timestamp:{}, version:{}, sign:{}, event_type:{}, event:{}",
                app_id, timestamp, version, sign, event_type, event);
        //验签
        StringBuffer signSb = new StringBuffer();
        signSb.append(app_id).append(timestamp).append(version)
                .append(event_type).append(event);
        try {
            boolean verifyFlag = DSAUtil.verify(DSAUtil.getPublicKey(DSA_PUBLIC_KEY), signSb.toString(), sign);
            if(!verifyFlag) {
                log.error("签名验证失败");
                return "SIGN FAIL";
            }
            log.info("签名验证成功");
            return "SUCCESS";
        } catch (Exception e) {
            return "SYSTEM ERROR";
        }
    }
}
